<template>
  <v-app>
    <v-navigation-drawer
      app
      overflow
      permanent
      v-model="drawer"
    >
      <v-list>
        <v-list-item
            link
            v-for="route in routes"
            :key="route.name"
            :to="route"
        >
          <v-list-item-title>{{ route.meta.title }}</v-list-item-title>
        </v-list-item>
      </v-list>
    </v-navigation-drawer>

    <v-main>
      <slot />
      <router-view />
    </v-main>
  </v-app>
</template>

<script>
export default {
  name: "DefaultLayout",
  data: () => ({
    drawer: null,
    routes: [],
  }),
  methods: {
    getRoutes(routes) {
      let result = [];

      for (const route of routes) {
        if (route.children) {
          result = [...result, ...this.getRoutes(route.children)];
        }

        if (route.meta) {
          result.push(route);
        }
      }

      return result;
    },
  },
  created() {
    this.routes = this.getRoutes(this.$router.options.routes);
  }
}
</script>
